; spiffMILL/theme.jl

;; Copyleft (C) 1999 Garrett LeSage

;; Based off of my spiffE Enlightenment theme....

;; The font

(defvar spiffMILL:font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1")

;; Images

(defvar spiffMILL:title-images (list (make-image "title-bar-inactive.png")
                                  (make-image "title-bar-active.png")))

(defvar spiffMILL:iconify-images (list (make-image "iconify-normal.png")
                                     nil nil
                                    (make-image "iconify-clicked.png")))

(defvar spiffMILL:maximize-images (list (make-image "maximize-normal.png")
                                      nil nil
                                     (make-image "maximize-clicked.png")))

(defvar spiffMILL:close-images (list (make-image "close-normal.png")
                                   nil nil
                                  (make-image "close-clicked.png")))

(defvar spiffMILL:border-top (make-image "border_top.xpm"))
(defvar spiffMILL:border-bottom (make-image "border_bottom.xpm"))
(defvar spiffMILL:border-right (make-image "border_right.xpm"))
(defvar spiffMILL:border-left (make-image "border_left.xpm"))

(defvar spiffMILL:corner-tl (make-image "corner_top_left.xpm"))
(defvar spiffMILL:corner-tr (make-image "corner_top_right.xpm"))
(defvar spiffMILL:corner-bl (make-image "corner_bottom_left.xpm"))
(defvar spiffMILL:corner-br (make-image "corner_bottom_right.xpm"))

;; frame layout

(defvar spiffMILL:frame
  `(
    ;; spacer
     ((background . ,spiffMILL:title-images)
      (top-edge . -12)
      (left-edge . 0)
      (class . iconify-button))

    ;; title
     ((background . ,spiffMILL:title-images)
      (foreground . ("grey" "white"))
      (font . ,spiffMILL:font)
      (text . window-name)
      (x-justify . 4)
      (y-justify . center)
      (top-edge . -12)
      (left-edge . 12)
      (right-edge . 0)
      (class . title))

    ;; iconify button
     ((background . ,spiffMILL:iconify-images)
      (top-edge . -11)
      (left-edge . 1)
      (class . iconify-button))

    ;; maximize button
     ((background . ,spiffMILL:maximize-images)
      (top-edge . -11)
      (right-edge . 13)
      (class . maximize-button))

    ;; close button
     ((background . ,spiffMILL:close-images)
      (top-edge . -11)
      (right-edge . 1)
      (class . close-button))

    ;; left border
     ((background . ,spiffMILL:border-left)
      (top-edge . -12)
      (bottom-edge . 0)
      (left-edge . -2)
      (class . left-border))

    ;; right border
     ((background . ,spiffMILL:border-right)
      (top-edge . -12)
      (bottom-edge . 0)
      (right-edge . -2)
      (class . right-border))

    ;; top border
     ((background . ,spiffMILL:border-top)
      (top-edge . -14)
      (right-edge . 0)
      (left-edge . 0)
      (class . top-border))

    ;; bottom border
     ((background . ,spiffMILL:border-bottom)
      (bottom-edge . -2)
      (right-edge . 0)
      (left-edge . 0)
      (class . bottom-border))

    ;; top-left corner
     ((background . ,spiffMILL:corner-tl)
      (top-edge . -14)
      (left-edge . -2)
      (class . top-left-corner))

    ;; top-right corner
     ((background . ,spiffMILL:corner-tr)
      (top-edge . -14)
      (right-edge . -2)
      (class . top-right-corner))

    ;; bottom-left corner
     ((background . ,spiffMILL:corner-bl)
      (bottom-edge . -2)
      (left-edge . -2)
      (class . bottom-left-corner))

    ;; bottom-right corner
     ((background . ,spiffMILL:corner-br)
      (bottom-edge . -2)
      (right-edge . -2)
      (class . bottom-right-corner))
))

;; Shaded view.
(defvar spiffMILL:shaped-frame
  `(
    ;; spacer
     ((background . ,spiffMILL:title-images)
      (top-edge . -12)
      (left-edge . 0)
      (class . iconify-button))
      
    ;; title
     ((background . ,spiffMILL:title-images)
      (foreground . ("grey" "white"))
      (font . ,spiffMILL:font)
      (text . window-name)
      (x-justify . 4)
      (y-justify . center)
      (top-edge . -12)
      (left-edge . 12)
      (right-edge . 0)
      (class . title))

    ;; iconify button
     ((background . ,spiffMILL:iconify-images)
      (top-edge . -11)
      (left-edge . 1)
      (class . iconify-button))

    ;; maximize button
     ((background . ,spiffMILL:maximize-images)
      (top-edge . -11)
      (right-edge . 13)
      (class . maximize-button))

    ;; close button
     ((background . ,spiffMILL:close-images)
      (top-edge . -11)
      (right-edge . 1)
      (class . close-button))

    ;; left border
     ((background . ,spiffMILL:border-left)
      (top-edge . -12)
      ;;(bottom-edge . 0)
      (left-edge . -2)
      (class . left-border))

    ;; right border
     ((background . ,spiffMILL:border-right)
      (top-edge . -12)
      ;;(bottom-edge . 0)
      (right-edge . -2)
      (class . right-border))

    ;; top border
     ((background . ,spiffMILL:border-top)
      (top-edge . -14)
      (right-edge . 0)
      (left-edge . 0)
      (class . top-border))

    ;; bottom border
     ((background . ,spiffMILL:border-bottom)
      (top-edge . 0)
      (right-edge . 0)
      (left-edge . 0)
      (class . bottom-border))

    ;; top-left corner
     ((background . ,spiffMILL:corner-tl)
      (top-edge . -14)
      (left-edge . -2)
      (class . top-left-corner))

    ;; top-right corner
     ((background . ,spiffMILL:corner-tr)
      (top-edge . -14)
      (right-edge . -2)
      (class . top-right-corner))

    ;; bottom-left corner
     ((background . ,spiffMILL:corner-bl)
      (top-edge . 0)
      (left-edge . -2)
      (class . bottom-left-corner))

    ;; bottom-right corner
     ((background . ,spiffMILL:corner-br)
      (top-edge . 0)
      (right-edge . -2)
      (class . bottom-right-corner))
))

(defvar spiffMILL:transient-frame
  `(
    ;; spacer
     ((background . ,spiffMILL:title-images)
      (top-edge . -12)
      (left-edge . 0)
      (class . iconify-button))

    ;; title
     ((background . ,spiffMILL:title-images)
      (foreground . ("grey" "white"))
      (font . ,spiffMILL:font)
      (text . window-name)
      (x-justify . 4)
      (y-justify . center)
      (top-edge . -12)
      (left-edge . 12)
      (right-edge . 0)
      (class . title))

    ;; iconify button
     ((background . ,spiffMILL:iconify-images)
      (top-edge . -11)
      (left-edge . 1)
      (class . iconify-button))

    ;; close button
     ((background . ,spiffMILL:close-images)
      (top-edge . -11)
      (right-edge . 1)
      (class . close-button))

    ;; left border
     ((background . ,spiffMILL:border-left)
      (top-edge . -12)
      (bottom-edge . 0)
      (left-edge . -2)
      (class . left-border))

    ;; right border
     ((background . ,spiffMILL:border-right)
      (top-edge . -12)
      (bottom-edge . 0)
      (right-edge . -2)
      (class . right-border))

    ;; top border
     ((background . ,spiffMILL:border-top)
      (top-edge . -14)
      (right-edge . 0)
      (left-edge . 0)
      (class . top-border))

    ;; bottom border
     ((background . ,spiffMILL:border-bottom)
      (bottom-edge . -2)
      (right-edge . 0)
      (left-edge . 0)
      (class . bottom-border))

    ;; top-left corner
     ((background . ,spiffMILL:corner-tl)
      (top-edge . -14)
      (left-edge . -2)
      (class . top-left-corner))

    ;; top-right corner
     ((background . ,spiffMILL:corner-tr)
      (top-edge . -14)
      (right-edge . -2)
      (class . top-right-corner))

    ;; bottom-left corner
     ((background . ,spiffMILL:corner-bl)
      (bottom-edge . -2)
      (left-edge . -2)
      (class . bottom-left-corner))

    ;; bottom-right corner
     ((background . ,spiffMILL:corner-br)
      (bottom-edge . -2)
      (right-edge . -2)
      (class . bottom-right-corner))
))

;; Frame definition

(defun spiffMILL:frame-style (w type)
  (cond ((eq type 'unframed) 'nil-frame)
        ((eq type 'shaped) 'spiffMILL:shaped-frame)
        ((eq type 'transient) 'spiffMILL:transient-frame)
        ((eq type 'shaped-transient) 'spiffMILL:transient-frame)
        (t 'spiffMILL:frame)))

(add-frame-style 'spiffMILL 'spiffMILL:frame-style)

